%% INTERFEJS
xp = 50;
yp = 760;
fig = figure(1);
delete(get(fig,'Children'));
set(fig,'Position',get(0,'Screensize'));
set(fig,'Name','HeatMRS - ustalony przeplyw ciepla za pomoca MRS / stationary heat flow analysis by means of the FDM (S.Milewski, 09.2016, v.1.1)')
set(fig','NumberTitle','off');
uicontrol('Position',[xp,yp,300,30],'Style','text','String','PUNKTY KRAWDZI (EDGE POINTS):',...
    'HorizontalAlignment','center','FontWeight','bold');
blad_pun = 0;
for i = 1:ilp
    for j = 1:ilp
        if i ~= j
            if Xk(i) == Xk(j) && Yk(i) == Yk(j)
                blad_pun = 1;
            end
        end
        if blad_pun == 1
            break;
        end
    end
    if blad_pun == 1
        break;
    end
end
if blad_pun == 1
    uicontrol('Position',[xp,yp,300,15],'Style','text','String','PUNKTY POKRYWAJ SI / POINTS COINCIDE!',...
        'HorizontalAlignment','center','ForegroundColor','r','FontWeight','bold');
end
blad_lin = 0;
if brzeg == 1
    dx = 350;
    uicontrol('Position',[xp + dx,yp,300,30],'Style','text','String','LINIE KRAWDZI (EDGE LINES):',...
        'HorizontalAlignment','center','FontWeight','bold');
    for i = 1:ilp
        if min(Kr(i,1:2)) > 0
            for j = 1:ilp
                if i ~= j
                    if min(Kr(i,1:2)) == min(Kr(j,1:2)) && max(Kr(i,1:2)) == max(Kr(j,1:2))
                        blad_lin = 1;
                    end
                end
                if blad_lin == 1
                    break;
                end
            end
            if Kr(i,1) == Kr(i,2)
                blad_lin = 1;
            end
            if blad_lin == 1
                break;
            end
        end
    end
    if blad_lin == 1
        uicontrol('Position',[xp + dx,yp,300,15],'Style','text','String','LINIE POKRYWAJ SI / LINES COINCIDE!',...
            'HorizontalAlignment','center','ForegroundColor','r','FontWeight','bold');
    end
end
e_pun = zeros(ilp+1,10);
log = 'on';
if brzeg == 1
    log = 'off';
end
for i = 1:ilp+1
    s1 = '';
    s2 = '';
    if i <= ilp
        s1 = num2str(Xk(i));
        s2 = num2str(Yk(i));
    end
    t1 = uicontrol('Position',[xp,yp-20*i,50,15],'Style','text','String',['X(',num2str(i),') = ']);
    s = '';
    if i <= ilp
        s = 'HeatMRS_points;';
    end
    e_pun(i,1) = uicontrol('Position',[xp+60,yp-20*i,50,15],'Style','edit','String',s1,'Enable',log,'Callback',s);
    t2 = uicontrol('Position',[xp+120,yp-20*i,50,15],'Style','text','String',['Y(',num2str(i),') = ']);
    e_pun(i,2) = uicontrol('Position',[xp+180,yp-20*i,50,15],'Style','edit','String',s2,'Enable',log,'Callback',s);
    if i == ilp + 1
        set([t1 t2 e_pun(i,1) e_pun(i,2)],'Visible',log);
    end
    if i <= ilp
        e_pun(i,3) = uicontrol('Position',[xp+240,yp-20*i,15,15],'Style','checkbox','Visible',log);
    end
    %     if i<= ilp
    %         e_pun(i,3) = uicontrol('Position',[xp+240,yp-20*i,100,15],'Style','pushbutton','Visible',log,'String','USU / DELETE',...
    %             'CallBack','[Xk,Yk,ilp] = HeatMRS_delpoint(Xk,Yk,ilp,i); HeatMRS_interface;');
    %     end
    %     if i == ilp + 1
    %         e_pun(i,3) = uicontrol('Position',[xp+240,yp-20*i,100,15],'Style','pushbutton','Visible',log,'String','DODAJ / ADD',...
    %             'CallBack','HeatMRS_newpoint;');
    %     end
end

if brzeg == 1
    log = 'on';
    if siat == 1
        log = 'off';
    end
    e_kr = zeros(ilp+1,10);
    for i = 1:ilp
        uicontrol('Position',[xp + dx,yp-20*i,250,15],'Style','text','String',['PUNKTY KRAWDZI / LINE EDGE POINTS (#',num2str(i),')']);
        e_kr(i,1) = uicontrol('Position',[xp + dx + 260,yp-20*i,40,15],'Style','popupmenu','String',['...',{1:ilp}],'Value',Kr(i,1)+1,...
            'Enable',log,'CallBack','HeatMRS_lines','FontSize',6);
        e_kr(i,2) = uicontrol('Position',[xp + dx + 310,yp-20*i,40,15],'Style','popupmenu','String',['...',{1:ilp}],'Value',Kr(i,2)+1,...
            'Enable',log,'CallBack','HeatMRS_lines','FontSize',6);
    end
end

log = 'on';
if brzeg == 1
    log = 'off';
end

yp = yp - 20*(ilp+3);
uicontrol('Position',[xp,yp,220,20],'Style','pushbutton','Visible',log,'String','DODAJ NOWY PUNKT / ADD NEW POINT',...
    'CallBack','HeatMRS_newpoint;');
il = 0;
for i = 1:ilp
    if get(e_pun(i,3),'Value') == 1
        il = il + 1;
    end
end
if ilp == 0
    log = 'off';
end
log1 = 'on';
uicontrol('Position',[xp+240,yp,200,20],'Style','pushbutton','Visible',log,'Enable',log1,'String','USU WYBRANE / DELETE SELECTED',...
    'CallBack','HeatMRS_delpoint; HeatMRS_interface;');

yp = yp - 30;
if ilp >= 3
    s = 'BRZEG WG LINII / BOUNDARY BY LINES';
    if brzeg == 1
        s = 'USU BRZEG / REMOVE BOUNDARY';
    end
    log = 'on';
    if siat == 1
        log = 'off';
    end
    e_brzeg1 = uicontrol('Position',[xp,yp,220,20],'Style','pushbutton','String',s,'Enable',log,...
        'CallBack','brzeg = ~brzeg; autom = 0; HeatMRS_boundary; HeatMRS_interface;');
    log = 'off';
    if brzeg == 0
        log = 'on';
    end
    e_brzeg2 = uicontrol('Position',[xp + 240,yp,260,20],'Style','pushbutton','String','BRZEG WG PUNKTW / BOUNDARY BY POINTS','Enable',log,...
        'CallBack','brzeg = 1; autom = 1; HeatMRS_boundary; HeatMRS_interface;');
    %e_brzeg3 = uicontrol('Position',[xp + 490,yp,200,20],'Style','pushbutton','String','BRZEG OTOCZKA / CONVEX HULL','Enable',log,...
    %   'CallBack','brzeg = 1; autom = 2; HeatMRS_boundary; HeatMRS_interface;');
end
yp = yp - 40;
if brzeg == 1
    uicontrol('Position',[xp,yp,200,30],'Style','text','String',...
        'TEMPERATURA NA BRZEGU / BOUNDARY TEMPERATURE [C]','FontWeight','bold');
    e_temp = uicontrol('Position',[xp+210,yp+5,50,20],'style','edit','String',num2str(Tb),...
        'CallBack','HeatMRS_parameters;');
end
yp = yp - 40;
uicontrol('Position',[xp,yp,200,30],'Style','text','String',...
    'INTENSYWNO OBCIENIA / HEAT LOAD INTENSITY f(x,y)','FontWeight','bold');
e_fun = uicontrol('Position',[xp+210,yp+5,200,20],'style','edit','String',fun,...
    'CallBack','HeatMRS_parameters;');
yp = yp - 40;
uicontrol('Position',[xp,yp,200,30],'Style','text','String',...
    'WSPӣCZYNNIK PRZEWODNICTWA / CONDUCTIVITY COEFF. k','FontWeight','bold');
e_wsp = uicontrol('Position',[xp+210,yp+5,200,20],'style','edit','String',wsp,...
    'CallBack','HeatMRS_parameters;');
yp = yp - 40;
if brzeg == 1
    e_gest = zeros(2,1);
    uicontrol('Position',[xp,yp,200,30],'Style','text','String',...
        'GSTO SIATKI po x / MESH DENSITY in x','FontWeight','bold');
    log = 'on';
    if siat == 1
        log = 'off';
    end
    e_gest(1) = uicontrol('Position',[xp+210,yp+5,50,20],'Style','popupmenu','String',{1:10},'Value',nx,...
        'Enable',log,'CallBack','HeatMRS_parameters;');
    uicontrol('Position',[xp,yp-40,200,30],'Style','text','String',...
        'GSTO SIATKI po y / MESH DENSITY in y','FontWeight','bold');
    e_gest(2) = uicontrol('Position',[xp+210,yp-35,50,20],'Style','popupmenu','String',{1:10},'Value',ny,...
        'Enable',log,'CallBack','HeatMRS_parameters;');
    s = 'GENERUJ SIATK / GENERATE MESH';
    if siat == 1
        s = 'USU SIATK / REMOVE MESH';
    end
    log = 'on';
    if blad_pun == 1 || blad_lin == 1
        log = 'off';
    end
    e_siat = uicontrol('Position',[xp + 270,yp-15 + 20,200,20],'Style','pushbutton','String',s,...
        'Enable',log,'CallBack','siat = ~siat; rozw = 0; HeatMRS_mesh; HeatMRS_interface;');
    if siat == 1       
        s = 'POKA NUMERY WZW / SHOW NODE NUMBERS';
        if RYS(3) == 1
            s = 'SCHOWAJ NUMERY WZW / HIDE NODE NUMBERS';
        end
        e_num = uicontrol('Position',[xp + 270,yp-15 - 20,300,20],'Style','pushbutton','String',s,...
        'Enable',log,'CallBack','log = RYS(3); log = ~log; RYS(3) = log; HeatMRS_interface;');
    end
end
yp = yp - 70;
if siat == 1
    uicontrol('Position',[xp,yp,200,20],'Style','text','String',...
        'TYP METODY / METHOD''s TYPE','FontWeight','bold');
    e_met = uicontrol('Position',[xp+210,yp,200,20],'Style','popupmenu',...
        'String',{'MRS / FDM','bezsiatkowa MRS / meshless FDM'},'Value',met,...
        'CallBack','HeatMRS_parameters;');
end
yp = yp - 30;
if siat == 1
    s = 'ROZWI ZADANIE / SOLVE A PROBLEM';
    if rozw == 1
        s = 'WYNIKI AKTUALNE / CURRENT RESULTS';
    end
    e_siat = uicontrol('Position',[xp,yp,260,20],'Style','pushbutton','String',s,...
        'CallBack','HeatMRS_solver; HeatMRS_interface;');
end
yp = yp - 30;
uicontrol('Position',[xp,yp,260,20],'Style','pushbutton','String','ZAPIS DO PLIKU / SAVE TO A FILE',...
    'CallBack','HeatMRS_zapisz; HeatMRS_interface;');
yp = yp - 30;
uicontrol('Position',[xp,yp,260,20],'Style','pushbutton','String','ODCZYT Z PLIKU / LOAD A FILE',...
    'CallBack','HeatMRS_wczytaj; HeatMRS_interface;');
yp = yp - 30;
uicontrol('Position',[xp,yp,260,20],'Style','pushbutton','String','NOWE ZADANIE / NEW PROBLEM',...
    'CallBack','HeatMRS_data; HeatMRS_interface;');
HeatMRS_plot;
set(fig,'MenuBar','figure');
set(fig,'ToolBar','figure');

if rozw == 1
    fig = figure(2);
    pos = get(fig,'Position');
    screen = get(0,'Screensize');
    set(fig,'Position',[screen(1) screen(2) + screen(4)/2.5 screen(3) screen(4)/2]);
    hold off
    nw = sum(WB == 0);
    plot([0 100 100 0 0],[0 0 10*(min([36 nw])+2) 10*(min([36 nw])+2) 0],'b-','linewidth',2);
    hold on
    j = 0; k = 0;
    for i = 1:n
        s = '';
        if WB(i) == 1
            s = '(brzeg)';
        end        
        if WB(i) == 0
            j = j + 1;
            t = text(1 + k*20,10*(min([36 nw])+2) - j*10,['i = ',sprintf('%d',i),', x = ',sprintf('%.2f',X(i)),', y = ',...
                sprintf('%.2f',Y(i)),' T = ',sprintf('%.2f',Temp(i)),'^oC ',s],'FontSize',8);            
            if j >= 36
                j = 0; k = k + 1;
            end
        end
    end
    axis tight
    axis off
end
set(fig,'name','REZULTATY OBLICZE - TEMPERATURY WZOWE')
title('REZULTATY OBLICZE - TEMPERATURY WZOWE')